%ext ck1

%version 1.31


#====MENU====
#Versatile Main Menu patch:
#Main Menu size
%patch $9601 $07 #Height
%patch $9605 $12 #Width

#Number of menu items
%patch $9414 $04 
%patch $938F $04 
%patch $95CD $04 

#Menu pointers (What items DO)
%patch $95ED $9570W #New game	 '   New Game'
             $9577W #Load game	 '   Load Game'
             $95B5W #Previews	 '   Story'
             $957FW #Story	 '   How to Play'
             $9589W #About Id	 '   About Me'

#Positionable menu (Bottom, right, top, left.) 
%patch $9601 $0014W  $50 $B8 $0020W  $50 $B8 $000DW  $50 $B8 $0010W  $50 $E8 
             $C90BW  $83 $C4 $08 $A1 $8282W  $99 $A3 $AAF4W  $89 $16 $F6 $AA 
             $A1 $82F8W  $99 $A3 $AAF8W  $89 $16 $FA $AA $B8 $27D8W  $50 $E8 
             $CC9FW  $44 $44 $EB $3E

#Menu text
%patch $15828 "   New Game" $0A
              "   Load Game" $0A
              "   Story" $0A
              "   How to Play" $0A
              "   About Me" $0A $0A
              "" $00

# The title bitmap will be shown at offset 0,0 
%patch $97B2   $00 $00     # Y location, in pixels 
%patch $97B6   $04 $00     # (X location in pixels) / 8 + 4

#Stop demo sequence
%patch $9A3E $90 $90

%patch $15F6A "" $00 #arrows, joystick, mouse text
%patch $15F71 "" $00 
%patch $15F77 "" $00

%patch $97CB $90 $90 $90 #F1 bitmap goes away

#Disable help menu
%patch $0C92 $90 $90

#Don't show the four items (Whether they have been picked up or not)
%patch $9928 $90 #Joystick
%patch $995B $90 #Battery
%patch $998E $90 #Vacuum cleaner
%patch $99C1 $90 #Whiskey

#Don't show bitmaps in high scores
%patch $9874 $EB $10 #High Scores
%patch $9886 $EB $10 #Name
%patch $9898 $EB $10 #Score
%patch $98AA $EB $10 #Parts

#Game over doesn't trigger high scores
%patch $8B42 $90 $90

#Hide high score names
%patch $9A03 $F0 #Names

#Hide ordering info sprites
%patch $A343 $EB $2E

#Blank O.I text (520 chars free at $1632C)
%patch $A497 $C3

#About Id
%patch $15F80 "Hello and welcome to Mura!            " $0A $00
%patch $15FA8 "My name is Nospike and I am a Keen    " $0A $00
%patch $15FD0 "modder, part of the community         " $0A $00
%patch $15FF8 "since early 2010.                    " $0A $0A $00
%patch $16020 "I've always loved horror games with   " $0A $00
%patch $16048 "a good story and creepy atmosphere.  " $0A $0A $00
%patch $16070 "After a failed mod called             " $0A $00
%patch $16098 "'Botafloria Is Out Of Flowers',       " $0A $00
%patch $160C0 "I created Mura in an attempt to       " $0A $00
%patch $160E8 "introduce those themes to a Keen      " $0A $00
%patch $16110 "mod. Hope you have a nice spook. :)   " $0A $00


#====MAP====
#Enter levels by touching their squares
%patch $AAAA $EB

#32 levels:
#Let Keen enter levels if these values are 0
%patch $7D3A  $90 $90 $80 $BF $A6 $AA $00
%patch $7FCA  $90 $90 $80 $BF $A5 $AA $00
#When starting a new game, make all 32 levels not done
%patch $9065  $90 $90 $C6 $87 $A6 $AA $00 $90
%patch $9070  $83 $7E $F8 $20
#Change things when marking a level as done
%patch $8013  $90 $90 $C6 $87 $A5 $AA $01 $90
%patch $7E48  $83 $7E $FC $20


#====GAMEPLAY====
#Framerate
%patch $26A $05

#In Game Tile Animation Speed 
%patch $7CDE $02

#Change the teleporter so it works within the level
%patch $8919                           $89 $F0 $F7 $2E $08 $6C $01 
   $F8 $D1 $E0 $C4 $1E $4C $6C $01 $C3 $26 $8B $07 $50 $88 $E0 $98 
   $99 $01 $F0 $83 $D2 $00 $B1 $0C $E8 $16 $58 $89 $16 $E4 $6E $A3 
   $E2 $6E $05 $00 $B0 $83 $D2 $FF $A3 $D4 $6E $89 $16 $D6 $6E $58 
   $98 $99 $01 $F8 $83 $D2 $00 $B1 $0C $E8 $F5 $57 $89 $16 $E0 $6E 
   $A3 $DE $6E $05 $00 $70 $83 $D2 $FF $A3 $D0 $6E $89 $16 $D2 $6E 
   $C3 
%patch $4572  $E8 $A4 $43 $EB $13 $90

#Keen walking
%patch $39C0 $FFACW #Left speed -initial
%patch $39B1 $0054W #Right speed -initial
%patch $2BC5 $FFDFW #Left speed
%patch $2BB6 $0020W #Right speed
%patch $39F6 $05    #Animation speed right
%patch $3A19 $05    #Animation speed left
%patch $4118 $05    #Animation speed exit

#Keen dying
#Keen dies sequence and keeps keycards on level exit 
%patch $41F8 $55 $8B $EC $C7 $06 $5DAAW  $0001W  $A1 $824AW  $03 $06 $5B14W 
             $A3 $824AW  $3D $0064W  $7E $0C $C7 $06 $8248W  $0017W  $C7 $06 
             $8252W  $421EW  $5D $C3 
%patch $421E $55 $8B $EC $A1 $824AW  $03 $06 $5B14W  $A3 $824AW  $3D $00C4W 
             $7E $0C $C7 $06 $8248W  $001DW  $C7 $06 $8252W  $423EW  $5D $C3 
%patch $423E $55 $8B $EC $A1 $824AW  $03 $06 $5B14W  $A3 $824AW  $3D $0124W 
             $7E $0C $C7 $06 $8248W  $001EW  $C7 $06 $8252W  $4F45W  $5D $C3 
%patch $4F43 $EB $1A $55 $8B $EC $A1 $824AW  $03 $06 $5B14W  $A3 $824AW  $3D #Overwrites keycard patch! 
             $0184W  $7E $06 $C7 $06 $8220W  $0000W  $5D $C3

#Jump height in half tiles
%patch $3BAC $0006W

#More efficient Ice-normal slide-walk code 
%patch $39E6 $08 $C7 $06 $48 $82 $0000W  $EB $06 $C7 $06 $48 $82 $0004W  $83 
             $FF $03 $7D $2F $A1 $5135W  $B1 $05 $D3 $E8 $25 $0003W  $8B $16 
             $48 $82 $03 $D0 $89 $16 $48 $82 $EB $19 

#Keen ducks when he presses the down key 
%patch $55EF $2E $A1 $46EEW  $8B $1E $CA $7F $D1 $E3 $2E $FF $A7 $4A48W  $2E 
             $A1 $4A5CW  $2E $A3 $39EBW  $2E $A3 $39D4W  $2E $A1 $4A60W  $2E 
             $A3 $39F3W  $2E $A3 $39DCW  $2E $A1 $4A64W  $2E $A3 $3A02W  $EB $1B 

#Unduck code 
%patch $0AF2 $2E $A1 $4A5AW  $2E $A3 $39EBW  $2E $A3 $39D4W  $2E $A1 $4A5EW 
             $2E $A3 $39F3W  $2E $A3 $39DCW  $2E $A1 $4A62W  $2E $A3 $3A02W 
             $E9 $4B26W 

#Jump table: Unduck whenever not pressing down arrow 
%patch $4A45 $C3 $0AF2W  $0AF2W  $0AF2W  $0AF2W  $55FEW  $55FEW 
                 $55FEW  $0AF2W  $0AF2W  $0AF2W  $0000W  $0018W 
                 $0004W  $001AW  $0003W  $0001W

#Space to shoot, Enter for status 
%patch $1251  $5048W 
%patch $7FA3  $5048W 
%patch $3B23  $90 $90 $90 $90 $90 $90 $90 $80 $3E $5065W $00 
%patch $3C4E  $90 $90 $90 $90 $90 $90 $90 $80 $3E $5065W $00 
%patch $3E6D  $90 $90 $90 $90 $90 $90 $90 $80 $3E $5065W $00 

#Weapon patch 
%patch $3E36 $90 $90 $90      #stop the shooting sound
%patch $3E5B $90 $90 $90      #don't play the 'click-out-of-ammo' sound 
%patch $3E3B $90 $90 $90 $90  #stop losing a shot [Infinite ammo] 
%patch $3E24 $90 $90          #Keen has a Machine Gun! 
%patch $4A38 110              #Zap 7 sprite 1 [Tank shots hit sprites] 
%patch $4A3F 110              #Zap 7 sprite 2 [Tank shots hit sprites]

#Don't do anything if Keen has no ammo, can't shoot when in air 
%patch $3B3F $83 $3E $AAC8W  $00 $74 $25 $33 $C0 $A3 $823CW  $A3 $824CW  $A3 
             $824AW  $C7 $06 $8252W  $3E12W  $C7 $06 $8248W  $0015W  $83 $3E 
             $604CW  $00 $7E $04 $FF $0E $8248W  $90 $90 $90 
%patch $3C5C $83 $3E $AAC8W  $00 $74 $25 $33 $C0 $A3 $823CW  $A3 $824CW  $A3 
             $824AW  $C7 $06 $8252W  $3E12W  $C7 $06 $8248W  $0015W  $83 $3E 
             $604CW  $00 $7E $04 $FF $0E $8248W  $5D $C3 
%patch $3DB9 $5E $5D $C3 

#Pogo: sound, animation, goto countdown 
%patch $3EC8 $55 $8B $EC $B8 $000CW  $50 $E8 $8021W  $44 $44 $C7 $06 $8248W 
             $001CW  $C7 $06 $8252W  $3EE2W  $5D $C3 

#Countdown to suicide - 88 ticks 
%patch $3EE2 $55 $8B $EC $A1 $824AW  $03 $06 $5B14W  $A3 $824AW  $3D $0088W 
             $7E $06 $C7 $06 $8252W  $41F8W  $5D $C3

#Minimal pogo height 
%patch $4085 $0000W

#Disable EKA (Free $0D76-$0DAF)
%patch $0D74 $5D $C3

#Keens left
%patch $15ED8 " Endurance" $00 #Text shown
%patch $8F5B $01D4W #The sprite used for keens

#Max lives
%patch $9000 $AAC6W $0006W #6 lives

#Don't draw exit tiles
%patch $4140 $90 $90 $90 #Top left tile
%patch $416A $90 $90 $90 #Bottom left tile
%patch $4194 $90 $90 $90 #Top right tile
%patch $41C4 $90 $90 $90 #Bottom right tile


#====ENEMIES====
#==Garg==
#Gargs stand still until they see Keen, then they run away
%patch $1BA3 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 
             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 
             $90 $90 $90


#====STATUS SCREEN====
#Extra Keen score
%patch $0FA0 $00    #Base to show Extra Keens score in ($0A = 10, $01 = binary, $00 don't show)

#Change the lives sprite
%patch $0FDE $B8 $01D4W  $50 $8B $46 $FE $05 $0003W  $D1 $E0 $D1 $E0 $D1 $E0
             $50 $8B $C7 $90

#Don't display ship parts
%patch $100A $E9 $00B9W
%patch $14E90 $0A $0A $0A $00
%patch $0E8D $EB $31
%patch $1007 $0D #How much space for lives

#Text
%patch $14E52 "    SCORE     EXTRA KEEN AT " $0A $00
%patch $14E70 " "                            $0A $00
%patch $14E73 "    KEENS       SHIP PARTS  " $0A $00
%patch $14E91 " "                            $0A $00
%patch $14E94 " "                            $0A $00
%patch $14E97 " "                            $0A $00
%patch $14E9A " RAYGUN   POGO    KEYCARDS  " $0A $00
%patch $14EB8 " "                            $00
%patch $14EBA " "                            $0A $00
%patch $14EBD " "                            $00
%patch $14EBF " "                            $0A $00
%patch $14EC2 " "                            $00
%patch $14EC4 " "                            $0A $00
%patch $14EC7 " CHARGE  "                    $00
%patch $14ED1 " "                            $0A $00
%patch $14ED4 " "                            $00
%patch $14ED6 " "                            $0A $00
%patch $14ED9 "     PLEASE PRESS A KEY     " $00


#====TEXT====
#Level 2 message scrolls 
%patch $252F $5C1FW $E9 $0175W 

#Message 
%patch $15080 "You hear in your    " $0A 
              "mind:               " $0A 
              "                    " $0A 
              "It is too bad that  " $0A 
              "you cannot read the " $0A 
              "Standard Galactic   " $0A 
              "Alphabet, Human.    " $0A $00


#====PALETTE====
#New palette patch
#First palette; modified
%patch $21850 
       00 00 00 #black
       00 00 42 #blue
       00 42 00 #green
       00 42 42 #cyan
       42 00 00 #red
       42 00 42 #magenta
       42 21 00 #brown
       42 42 42 #bright gray
       21 21 21 #gray
       21 21 63 #bright blue
       21 63 21 #bright green
       21 63 63 #bright cyan
       63 21 21 #bright red
       63 21 63 #pink
       63 63 21 #yellow
       63 63 63 #white
#Lights out palette
       00 00 00 #black
       00 00 42 #blue
       00 21 00 #green
       00 21 42 #cyan
       21 00 00 #red
       21 00 42 #magenta
       21 10 00 #brown
       21 21 42 #bright gray
       10 10 21 #gray
       10 10 63 #bright blue
       10 42 21 #bright green
       10 42 63 #bright cyan
       42 10 21 #bright red
       42 10 63 #pink
       42 42 21 #yellow
       63 63 63 #white

#----------------------------------------------------------------------------
#Set EGA color register values for VGA pass-through
%patch $1558B   $00 $01 $02 $03 $04 $05 $06 $07
                $08 $09 $0A $0B $0C $0D $0E $0F $03

#Set the palette when we go into graphics mode
%patch $6E46 $E8 $64 $FE $90 $90
 
#Code to set graphics mode and set the palette
%patch $6CAD $B8 $0D $00 $CD $10 $B8 $13 $10 $BB $00 $01 $CD $10 $B8 $02 $10
             $1E $07 $BA $3B $25 $CD $10 $B8 $12 $10 $B9 $20 $00 $31 $DB $BA
             $00 $E8 $CD $10 $C3
 
#support functions
%patch $5B3D $BA $DA $03 $EC $A8 $08 $75 $FB $EC $A8 $08 $74 $FB $C3 $55 $89
             $E5 $E8 $EC $FF $BA $DA $03 $EC $BA $C0 $03 $EC $50 $B0 $14 $EE
             $8B $46 $04 $EE $58 $EE $89 $EC $5D $C3 $55 $89 $E5 $83 $EC $08
             $31 $C0 $31 $DB $89 $46 $F8 $8A $87 $00 $E8 $2A $46 $04 $73 $02
             $31 $C0 $89 $46 $FA $43 $8A $87 $00 $E8 $2A $46 $04 $73 $02 $31
             $C0 $89 $46 $FC $43 $8A $87 $00 $E8 $2A $46 $04 $73 $02 $31 $C0
             $89 $46 $FE $43 $E8 $B9 $10 $FF $46 $F8 $83 $FB $60 $75 $C8 $89
             $EC $5D $C3
%patch $6C5D $55 $89 $E5 $BA $C8 $03 $8B $46 $04 $EE $BA $C9 $03 $8B $46 $06
             $EE $8B $46 $08 $EE $8B $46 $0A $EE $89 $EC $5D $C3
 
#VGA palette fading
#fade in
%patch $6C49 $B9 $20 $00 $E8 $EE $EE $89 $C8 $D1 $E0 $48 $50 $E8 $0F $EF $44
             $44 $E2 $F0 $C3 
#fade out
%patch $6C8D $B9 $20 $00 $E8 $AA $EE $B8 $40 $00 $D1 $E1 $29 $C8 $50 $E8 $C9
             $EE $44 $44 $D1 $E9 $E2 $EC $31 $C0 $50 $E8 $A1 $EE $44 $44 $C3 
 
#VGA lights
%patch $3592 $C7 $06 $1E $82 $01 $00 $B8 $01 $00 $50 $E8 $43 $8B $44 $44 $31
             $C0 $50 $E8 $A4 $25 $44 $44 $C3
%patch $35B2 $C7 $06 $1E $82 $00 $00 $B8 $01 $00 $50 $E8 $23 $8B $44 $44 $B8
             $01 $00 $50 $E8 $83 $25 $44 $44 $C3


#====================== Vorticons Extended =====================

#far segment code
%patchfile $10000 patch\atrseg.bin

# VIDEO --------------------------------------------------

#Far Call to ATR_0
%patch $B7B2 $10001000RL

#Far Call to ATR_1
%patch $B7AA $1000104DRL

#masked animations
#add si, [cur_anim_plane_nptr]; mov si, [si]; nop; nop
%patch $B9CE $03 $36 $BE $35 $8B $34 $90 $90 

# TILESETS -----------------------------------------------

# COMMENT OUT ONE OF THE FOLLOWING LINES
# Default: Using 4 Frames, 8 frame line commented out
%patch $18040 $00A8W $07C4W $0EE0W $15FCW $8372W $8A8EW $9740W $9E5CW # USE 8 FRAMES


# References to Animation and Info Planes
%patch $B799 $E #8 planes 
%patch $B79C $4FF0W #new anim plane offset array (above)

# Tileset Loader
%patchfile $13BF patch\loader.bin
%patch $676 $E8 $0D87W #call loader

# call tile collision routine
%patch $2C97 $9A $10000000RL $C3

# slopes on world map
%patchfile $A616 patch\mapslope.bin

# references to tileinfo type plane
%patch $045A $8A $87 $3A1CW $98 $90 #overwrite shl bx, 1; CODE: mov al, TileInfo_UEDGE[bx], 0; and al, 3; cbw; cmp al, 1
%patch $281E $8A $87 $3A1CW $98 $90
%patch $283D $8A $87 $3A1CW $98 $90
%patch $4364 $8A $87 $3A1CW $98 $90

# references to tileinfo uedge blocking
%patch $38C5 $8A $87 $3DAAW $24 $03 $98 $3C $01 #think_13_keen_ground: 

# references to tileinfo redge blocking
%patch $473D $80 $BF $4138W $0 $90 $90 #overwrite shl bx, 1; CODE: cmp byte ptr TileInfo_UEDGE[bx], 0; nop; nop;
%patch $495A $80 $BF $4138W $0 $90 $90

# references to tli DEdge blocking

# references to tli LEdge Blocking
%patch $382F $80 $BF $4854W $0 $90 $90
%patch $47B1 $80 $BF $4854W $0 $90 $90
%patch $49C9 $80 $BF $4854W $0 $90 $90

#============= END Vorticons Extended PATCH 320x200 ====================


%end
